<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_10</title>
</head>
<body>
    <h1>Capitulo 10</h1>
    <a>Ejercicio 2</a>

    <script>

        let NO_OF_CHARS = 26;
    
        class Node {
            constructor() {
                this.isEnd = false;
                this.child = new Array(NO_OF_CHARS);
                
                for (let i = 0; i < NO_OF_CHARS; i++) {
                    this.child[i] = null;
                }

                this.head = []; 
            }
        }

        const incertar = (root, word, index, i) => {
            
            if (root === null) {
                root = new Node();
            }

            if (i < word.length) {
                let index1 = word[i].charCodeAt(0) - 'a'.charCodeAt(0);
                root.child[index1] = incertar(root.child[index1], word, index, i+1);
            } else {
                if (root.isEnd === true) {
                    root.head.push(index);
                } else {
                    root.isEnd = true;
                    root.head.push(index);
                }
            }
            return root
        }

        const imprimirArrOrde = (root, wordArr) => {

            if (root === null)
                return;

                if (root.isEnd) {
                    for (var pCrawl = 0; pCrawl < root.head.length; pCrawl++) {
                        console.log(wordArr[root.head[pCrawl]]);
                    }
                }

                for (var i = 0; i < NO_OF_CHARS; ++i) {
                    imprimirArrOrde(root.child[i], wordArr);
                }
        }

        const imprimirArray = (wordArr, size) => {
            let root = null;

            for (var i = 0; i < size; ++i) {
                let buffer = wordArr[i].split("");
                (buffer).sort();
                root = incertar(root, (buffer).join(""), i, 0);
            }
            imprimirArrOrde(root, wordArr);
        }
 
        let wordArr = ["cat", "dog", "tac", "god", "act", "gdo"];
        let size = wordArr.length;

        imprimirArray(wordArr, size);
 
        
        
</script>
    
</body>
</html>